## openjk 0~20240620.c11082b+dfsg

=== CMakeLists.txt ===
#============================================================================
# Copyright (C) 2013 - 2018, OpenJK contributors
#
# This file is part of the OpenJK source code.
#
# OpenJK is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#============================================================================

cmake_minimum_required(VERSION 3.1)
set(CMAKE_OSX_DEPLOYMENT_TARGET "10.9" CACHE STRING "Minimum OS X deployment version")

set(InOpenJK ON)

set(ProjectName "OpenJK" CACHE STRING "Project Name")
project(${ProjectName})

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

#=============================================================================
#
# Customizable options
#
#=============================================================================
option(BuildPortableVersion "Build portable version (does not read or write files from your user/home directory" OFF)

option(BuildMPEngine "Whether to create projects for the MP client (openjk.exe)" ON)
option(BuildMPRdVanilla "Whether to create projects for the MP default renderer (rd-vanilla_x86.dll)" ON)
option(BuildMPDed "Whether to create projects for the MP dedicated server (openjkded.exe)" ON)
option(BuildMPGame "Whether to create projects for the MP server-side gamecode (jampgamex86.dll)" ON)
option(BuildMPCGame "Whether to create projects for the MP clientside gamecode (cgamex86.dll)" ON)
option(BuildMPUI "Whether to create projects for the MP UI code (uix86.dll)" ON)
option(BuildMPRend2 "Whether to create projects for the EXPERIMENTAL MP rend2 renderer (rd-rend2_x86.dll)" ON)

option(BuildSPEngine "Whether to create projects for the SP engine (openjk_sp.exe)" ON)
option(BuildSPGame "Whether to create projects for the SP gamecode (jagamex86.dll)" ON)
option(BuildSPRdVanilla "Whether to create projects for the SP default renderer (rdsp-vanilla_x86.dll)" ON)

option(BuildJK2SPEngine "Whether to create projects for the jk2 SP engine (openjo_sp.exe)" OFF)
option(BuildJK2SPGame "Whether to create projects for the jk2 sp gamecode mod (jk2gamex86.dll)" OFF)
option(BuildJK2SPRdVanilla "Whether to create projects for the jk2 sp renderer (rdjosp-vanilla_x86.dll)" OFF)

option(BuildTests "Whether to build automatic unit tests (requires Boost)" OFF)

include(CMakeDependentOption)
cmake_dependent_option(BuildSymbolServer "Build WIP Windows Symbol Server (experimental and unused)" OFF "NOT WIN32 OR NOT MSVC" OFF)

# Configure the use of bundled libraries.  By default, we assume the user is on
# a platform that does not require any bundling.
#
# Note that we always use the bundled copy of minizip, since it is modified to
# use Z_Malloc.

set(UseInternalOpenALDefault OFF)
set(UseInternalZlibDefault   OFF)
set(UseInternalPNGDefault    OFF)
set(UseInternalJPEGDefault   OFF)
set(UseInternalSDL2Default   OFF)

if(UseInternalLibs OR WIN32)
  set(UseInternalOpenALDefault ON)
  set(UseInternalZlibDefault   ON)
  set(UseInternalPNGDefault    ON)
  set(UseInternalJPEGDefault   ON)
  set(UseInternalSDL2Default   ON)
endif()

if(APPLE)
  set(UseInternalJPEGDefault ON)
endif()

option(UseInternalOpenAL "If set, use bundled OpenAL."  ${UseInternalOpenALDefault})
option(UseInternalZlib   "If set, use bundled zlib."    ${UseInternalZlibDefault})
option(UseInternalPNG    "If set, use bundled libpng."  ${UseInternalPNGDefault})
option(UseInternalJPEG   "If set, use bundled libjpeg." ${UseInternalJPEGDefault})
option(UseInternalSDL2   "If set, use bundled SDL2."    ${UseInternalSDL2Default})

# This option won't appear on non-Apple platforms.
if(APPLE)
  option(MakeApplicationBundles "Whether to build .app application bundles for engines built" ON)
endif()

#=============================================================================
#
# Custom CMake Modules needed
#
#=============================================================================
list(INSERT CMAKE_MODULE_PATH 0 "${CMAKE_SOURCE_DIR}/cmake/Modules")

if(CMAKE_EXPORT_COMPILE_COMMANDS)
	add_custom_target(
		copy-compile-commands ALL
		${CMAKE_COMMAND} -E copy_if_different
		${CMAKE_BINARY_DIR}/compile_commands.json
		${CMAKE_CURRENT_LIST_DIR})
endif()

#=============================================================================
#
# Architecture/OS defines
#
#=============================================================================
# ${Architecture} must match ARCH_STRING in q_platform.h,
# and is used in DLL names (jagamex86.dll, jagamex86.dylib, jagamei386.so).
if(WIN32)
	set(X86 ON)
	if(CMAKE_SIZEOF_VOID_P MATCHES "8")
		set(Architecture "x86_64")
		set(WIN64 TRUE)
	else()
		set(Architecture "x86")
		set(WIN64 FALSE)
	endif()
else()
	set(X86 OFF)
	if(CMAKE_SYSTEM_PROCESSOR MATCHES "^(arm64|aarch64)$")
		set(Architecture "arm64")
		add_definitions(-DPNG_ARM_NEON_OPT=0)
	elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^arm")
		set(Architecture "arm")
	elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^i.86$")
		set(X86 ON)
		if(APPLE)
			set(Architecture "x86")
		else()
			# e.g. Linux
			set(Architecture "i386")
		endif()
	elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^x86.64$")
		set(X86 ON)
		set(Architecture "x86_64")
	elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL "powerpc")
		set(Architecture "ppc")
	elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL "powerpc64")
		set(Architecture "ppc64")
	else()
		set(Architecture "${CMAKE_SYSTEM_PROCESSOR}")
	endif()
endif()

message(STATUS "Architecture is ${Architecture}")

if(WIN32 AND CMAKE_VERSION VERSION_LESS "3.4")
	message(WARNING "Building on Windows platform with CMake version less than 3.4 is deprecated. Manifest file will fail to be included.")
endif()

#=============================================================================
#
# Binary names
#
#=============================================================================
set(SPEngine "openjk_sp.${Architecture}")
set(SPGame "jagame${Architecture}")
set(SPRDVanillaRenderer "rdsp-vanilla_${Architecture}")
set(MPEngine "openjk.${Architecture}")
set(MPVanillaRenderer "rd-vanilla_${Architecture}")
set(MPDed "openjkded.${Architecture}")
set(MPGame "jampgame${Architecture}")
set(MPCGame "cgame${Architecture}")
set(MPUI "ui${Architecture}")
set(MPRend2 "rd-rend2_${Architecture}")
set(JK2SPEngine "openjo_sp.${Architecture}")
set(JK2SPGame "jospgame${Architecture}")
set(JK2SPVanillaRenderer "rdjosp-vanilla_${Architecture}")
set(AssetsPk3 "openjk-${Architecture}.pk3")
# Library names
set(MPBotLib "botlib")
set(SharedLib "shared")

#=============================================================================
#
# Paths
#
#=============================================================================
set(SPDir "${CMAKE_SOURCE_DIR}/code")
set(MPDir "${CMAKE_SOURCE_DIR}/codemp")
set(JK2SPDir "${CMAKE_SOURCE_DIR}/codeJK2")
set(SharedDir ${CMAKE_SOURCE_DIR}/shared)
set(OpenJKLibDir "${CMAKE_SOURCE_DIR}/lib")
set(GSLIncludeDirectory "${OpenJKLibDir}/gsl-lite/include")

include(InstallConfig)

#=============================================================================
#
# Compiler definitions/flags
#
#=============================================================================

# Operating system settings
if(WIN64)
	set(SharedDefines ${SharedDefines} "WIN64")
endif()

if (APPLE)
	set(SharedDefines ${SharedDefines} "MACOS_X")
endif()

if (NOT WIN32 AND NOT APPLE)
	set(SharedDefines ${SharedDefines} "ARCH_STRING=\"${Architecture}\"")
endif()

if(CMAKE_SYSTEM_NAME MATCHES "BSD")
  add_definitions(-DIOAPI_NO_64)
endif()

# Compiler settings
if(MSVC)
	set(SharedDefines ${SharedDefines} "NOMINMAX")
	set(SharedDefines ${SharedDefines} "_CRT_SECURE_NO_WARNINGS")
	set(SharedDefines ${SharedDefines} "_SCL_SECURE_NO_WARNINGS")
	set(SharedDefines ${SharedDefines} "_CRT_NONSTDC_NO_DEPRECATE")

	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /arch:SSE2")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /MP")

	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /arch:SSE2")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")

	# We don't try to control symbol visibility under MSVC.
	set(OPENJK_VISIBILITY_FLAGS "")
elseif (("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU") OR ("${CMAKE_C_COMPILER_ID}" MATCHES "Clang"))
	# I hope this doesn't come back to bite me in the butt later on.
	# Realistically though, can the C and CXX compilers be different?

	# Visibility can't be set project-wide -- it needs to be specified on a
	# per-target basis.  This is primarily due to the bundled copy of ZLib.
	# ZLib explicitly declares symbols hidden, rather than defaulting to hidden.
	#
	# Note that -fvisibility=hidden is stronger than -fvisibility-inlines-hidden.
	set(OPENJK_VISIBILITY_FLAGS "-fvisibility=hidden")

	# removes the -rdynamic flag at linking (which causes crashes for some reason)
	set(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS "")
	set(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS "")

	# additional flags for debug configuration
	set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -ggdb")
	set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -ggdb")

	if (X86)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -msse2")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse2")
	endif()

	set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O3")
	set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3")

	# enable somewhat modern C++
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")

	if("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU")
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-comment")
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsigned-char")
		if (X86)
			# "x86 vm will crash without -mstackrealign since MMX
			# instructions will be used no matter what and they
			# corrupt the frame pointer in VM calls"
			# -ioquake3 Makefile
			set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mstackrealign")
			set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mfpmath=sse")
		endif()

		if(WIN32)
			# Link libgcc and libstdc++ statically
			set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -static-libgcc")
			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -static-libgcc")
			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -static-libstdc++")
		endif()
	elseif("${CMAKE_C_COMPILER_ID}" MATCHES "Clang")
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-comment")
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsigned-char")
	endif()

	if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-invalid-offsetof")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-write-strings")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-comment")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsigned-char")
		if (X86)
			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mstackrealign")
			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mfpmath=sse")
		endif()
	elseif("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-write-strings")
		#set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-writable-strings")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-comment")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-invalid-offsetof")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsigned-char")
	endif()
else()
	message(ERROR "Unsupported compiler")
endif()

set(SharedDefines ${SharedDefines} "$<$<CONFIG:Debug>:_DEBUG>")
set(SharedDefines ${SharedDefines} "$<$<NOT:$<CONFIG:Debug>>:FINAL_BUILD>")

if(BuildPortableVersion)
	set(BUILD_PORTABLE ON)
endif()

#=============================================================================
#
# Generate version file
#

=== code/CMakeLists.txt ===
#============================================================================
# Copyright (C) 2013 - 2018, OpenJK contributors
#
# This file is part of the OpenJK source code.
#
# OpenJK is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#============================================================================

# Make sure the user is not executing this script directly
if(NOT InOpenJK)
	message(FATAL_ERROR "Use the top-level cmake script!")
endif(NOT InOpenJK)

#    Add Game Project
if(BuildSPGame)
	add_subdirectory("${SPDir}/game")
endif(BuildSPGame)

#    Add Modular Renderer project
add_subdirectory("${SPDir}/rd-vanilla")

#    Add Engine Project
if(BuildSPEngine OR BuildJK2SPEngine)
	# Libraries
	if(WIN32)
		set(SPEngineLibraries "winmm")
	endif(WIN32)
	# Defines
	set(SPEngineDefines ${SharedDefines} "_JK2EXE") # it's called JK2EXE but it really just means Singleplayer Exe

	set(SPEngineIncludeDirectories
		${SPEngineIncludeDirectories}
		${SharedDir}
		${CMAKE_BINARY_DIR}/shared
		${SPDir}
		"${GSLIncludeDirectory}")

	#    Dependencies
	# OpenAL (is optionally included for Windows)
	if(MSVC AND NOT WIN64)
		if(UseInternalOpenAL)
			# There's a libs/OpenAL32.lib
			# (mrw) TODO Is this actually required on windows? It is loaded at runtime, should not be linked?
			find_library(OpenALLibrary NAMES OpenAL32 PATHS "${OpenJKLibDir}")
			if(NOT OpenALLibrary)
				message(FATAL_ERROR "UseInternalOpenAL enabled, but lib/OpenAL32.lib not found!")
			endif(NOT OpenALLibrary)
			set(SPEngineLibraries ${SPEngineLibraries} ${OpenALLibrary})
		else(UseInternalOpenAL)
			find_package(OpenAL REQUIRED)
			set(SPEngineIncludeDirectories ${SPEngineIncludeDirectories} ${OPENAL_INCLUDE_DIR})
			set(SPEngineLibraries ${SPEngineLibraries} ${OPENAL_LIBRARY})
		endif(UseInternalOpenAL)

		set(SPEngineEAXFiles
			"${SPDir}/client/eax/eax.h"
			"${SPDir}/client/eax/EaxMan.h"
			)
		source_group("eax" FILES ${SPEngineEAXFiles})
		set(SPEngineFiles ${SPEngineFiles} ${SPEngineEAXFiles})
	endif()

	if(UseInternalSDL2)
		if(CMAKE_SIZEOF_VOID_P EQUAL 4)
			set(SPEngineLibraries
				${SPEngineLibraries}
				${OpenJKLibDir}/SDL2/lib/x86/SDL2main.lib
				${OpenJKLibDir}/SDL2/lib/x86/SDL2.lib
				)
		else()
			set(SPEngineLibraries
				${SPEngineLibraries}
				${OpenJKLibDir}/SDL2/lib/x64/SDL2main.lib
				${OpenJKLibDir}/SDL2/lib/x64/SDL2.lib
				)
		endif()

		set(SPEngineIncludeDirectories
			${SPEngineIncludeDirectories}
			${OpenJKLibDir}/SDL2/include
			)
	else()
		find_package(SDL2 REQUIRED CONFIG)
		if (TARGET SDL2::SDL2)
			set(SDL2_INCLUDE_DIRS "")
			set(SDL2_LIBRARIES SDL2::SDL2)
		endif()
		string(STRIP ${SDL2_LIBRARIES} SDL2_LIBRARIES)
		set(SPEngineIncludeDirectories ${SPEngineIncludeDirectories} ${SDL2_INCLUDE_DIRS})
		set(SPEngineLibraries ${SPEngineLibraries} ${SDL2_LIBRARIES})
	endif()

	#    Source Files

	# Client files
	set(SPEngineClientFiles
		"${SPDir}/client/keys.h"
		"${SPDir}/client/keycodes.h"

		"${SPDir}/client/cl_cgame.cpp"
		"${SPDir}/client/cl_cin.cpp"
		"${SPDir}/client/cl_console.cpp"
		"${SPDir}/client/cl_input.cpp"
		"${SPDir}/client/cl_keys.cpp"
		"${SPDir}/client/cl_main.cpp"
		"${SPDir}/client/cl_mp3.cpp"
		"${SPDir}/client/cl_parse.cpp"
		"${SPDir}/client/cl_scrn.cpp"
		"${SPDir}/client/cl_ui.cpp"
		"${SPDir}/client/cl_mp3.h"
		"${SPDir}/client/client.h"
		"${SPDir}/client/client_ui.h"

		"${SPDir}/client/snd_ambient.cpp"
		"${SPDir}/client/snd_dma.cpp"
		"${SPDir}/client/snd_mem.cpp"
		"${SPDir}/client/snd_mix.cpp"
		"${SPDir}/client/snd_music.cpp"
		"${SPDir}/client/snd_ambient.h"
		"${SPDir}/client/snd_local.h"
		"${SPDir}/client/snd_music.h"
		"${SPDir}/client/snd_public.h"

		"${SPDir}/client/vmachine.cpp"
		"${SPDir}/client/vmachine.h"
		)
	source_group("client" FILES ${SPEngineClientFiles})
	set(SPEngineFiles ${SPEngineFiles} ${SPEngineClientFiles})


	# qcommon files
	set(SPEngineCommonFiles
		"${SPDir}/qcommon/cm_load.cpp"
		"${SPDir}/qcommon/cm_patch.cpp"
		"${SPDir}/qcommon/cm_polylib.cpp"
		"${SPDir}/qcommon/cm_test.cpp"
		"${SPDir}/qcommon/cm_trace.cpp"
		"${SPDir}/qcommon/cm_local.h"
		"${SPDir}/qcommon/cm_patch.h"
		"${SPDir}/qcommon/cm_polylib.h"
		"${SPDir}/qcommon/cm_public.h"

		"${SPDir}/qcommon/cmd.cpp"
		"${SPDir}/qcommon/common.cpp"
		"${SPDir}/qcommon/cvar.cpp"

		"${SPDir}/qcommon/files.cpp"

		"${SPDir}/qcommon/md4.cpp"
		"${SPDir}/qcommon/msg.cpp"
		"${SPDir}/qcommon/net_chan.cpp"

		"${SPDir}/qcommon/q_shared.cpp"
		"${SPDir}/qcommon/q_shared.h"

		"${SPDir}/qcommon/sstring.h"
		"${SPDir}/qcommon/stringed_ingame.cpp"
		"${SPDir}/qcommon/stringed_interface.cpp"
		"${SPDir}/qcommon/stringed_ingame.h"
		"${SPDir}/qcommon/stringed_interface.h"

		"${SPDir}/qcommon/strip.cpp"
		"${SPDir}/qcommon/persistence.cpp"
		"${SPDir}/qcommon/tags.h"
		"${SPDir}/qcommon/z_memman_pc.cpp"
		"${SPDir}/qcommon/qfiles.h"
		"${SPDir}/qcommon/qcommon.h"
		"${SPDir}/qcommon/stv_version.h"
		"${SPDir}/qcommon/timing.h"
		"${SPDir}/qcommon/MiniHeap.h"

		"${SPDir}/qcommon/ojk_i_saved_game.h"
		"${SPDir}/qcommon/ojk_saved_game.h"
		"${SPDir}/qcommon/ojk_saved_game.cpp"
		"${SPDir}/qcommon/ojk_saved_game_helper.h"
		"${SPDir}/qcommon/ojk_saved_game_helper_fwd.h"
		"${SPDir}/qcommon/ojk_scope_guard.h"

		${SharedCommonFiles}
		)
	source_group("common" FILES ${SPEngineCommonFiles})
	set(SPEngineFiles ${SPEngineFiles} ${SPEngineCommonFiles})

	set(SPEngineCommonSafeFiles
		"${SharedDir}/qcommon/safe/files.cpp"
		"${SharedDir}/qcommon/safe/files.h"
		${SharedCommonSafeFiles}
		"${SPDir}/qcommon/safe/memory.h"
		)
	source_group("common/safe" FILES ${SPEngineCommonSafeFiles})
	set(SPEngineFiles ${SPEngineFiles} ${SPEngineCommonSafeFiles})


	# Server files
	set(SPEngineServerFiles
		"${SPDir}/server/exe_headers.cpp"
		"${SPDir}/server/sv_ccmds.cpp"
		"${SPDir}/server/sv_client.cpp"
		"${SPDir}/server/sv_game.cpp"
		"${SPDir}/server/sv_init.cpp"
		"${SPDir}/server/sv_main.cpp"
		"${SPDir}/server/sv_savegame.cpp"
		"${SPDir}/server/sv_snapshot.cpp"
		"${SPDir}/server/sv_world.cpp"
		"${SPDir}/server/exe_headers.h"
		"${SPDir}/server/server.h"
		)
	source_group("server" FILES ${SPEngineServerFiles})
	set(SPEngineFiles ${SPEngineFiles} ${SPEngineServerFiles})


	# Game files
	set(SPEngineGameFiles
		"${SPDir}/game/genericparser2.cpp"
		"${SPDir}/game/channels.h"
		"${SPDir}/game/anims.h"
		"${SPDir}/game/b_public.h"
		"${SPDir}/game/bg_public.h"
		"${SPDir}/game/bset.h"
		"${SPDir}/game/bstate.h"
		"${SPDir}/game/common_headers.h"
		"${SPDir}/game/g_functions.h"
		"${SPDir}/game/g_items.h"
		"${SPDir}/game/g_local.h"
		"${SPDir}/game/g_nav.h"
		"${SPDir}/game/g_public.h"
		"${SPDir}/game/g_shared.h"
		"${SPDir}/game/genericparser2.h"
		"${SPDir}/game/statindex.h"
		"${SPDir}/game/teams.h"
		"${SPDir}/game/weapons.h"
		"${SPDir}/game/surfaceflags.h"
		"${SPDir}/game/ghoul2_shared.h"
		)
	source_group("game" FILES ${SPEngineGameFiles})
	set(SPEngineFiles ${SPEngineFiles} ${SPEngineGameFiles})


	# MP3 files
	set(SPEngineMP3Files
		"${SPDir}/mp3code/cdct.c"
		"${SPDir}/mp3code/csbt.c"
		"${SPDir}/mp3code/csbtb.c"
		"${SPDir}/mp3code/csbtl3.c"
		"${SPDir}/mp3code/cup.c"
		"${SPDir}/mp3code/cupini.c"
		"${SPDir}/mp3code/cupl1.c"
		"${SPDir}/mp3code/cupl3.c"
		"${SPDir}/mp3code/cwin.c"
		"${SPDir}/mp3code/cwinb.c"
		"${SPDir}/mp3code/cwinm.c"
		"${SPDir}/mp3code/hwin.c"
		"${SPDir}/mp3code/l3dq.c"
		"${SPDir}/mp3code/l3init.c"
		"${SPDir}/mp3code/mdct.c"
		"${SPDir}/mp3code/mhead.c"
		"${SPDir}/mp3code/msis.c"
		"${SPDir}/mp3code/towave.c"
		"${SPDir}/mp3code/uph.c"
		"${SPDir}/mp3code/upsf.c"
		"${SPDir}/mp3code/wavep.c"
		"${SPDir}/mp3code/config.h"
		"${SPDir}/mp3code/htable.h"
		"${SPDir}/mp3code/jdw.h"
		"${SPDir}/mp3code/l3.h"
		"${SPDir}/mp3code/mhead.h"
		"${SPDir}/mp3code/mp3struct.h"
		"${SPDir}/mp3code/port.h"
		"${SPDir}/mp3code/small_header.h"
		"${SPDir}/mp3code/tableawd.h"
		)
	source_group("mp3" FILES ${SPEngineMP3Files})
	set(SPEngineFiles ${SPEngineFiles} ${SPEngineMP3Files})

	set(SPEngineRendererFiles
		"${SPDir}/rd-common/mdx_format.h"
		"${SPDir}/rd-common/tr_public.h"
		"${SPDir}/rd-common/tr_types.h"
		)
	source_group("renderer" FILES ${SPEngineRendererFiles})
	set(SPEngineFiles ${SPEngineFiles} ${SPEngineRendererFiles})

	# UI files
	set(SPEngineUIFiles
		"${SPDir}/ui/ui_atoms.cpp"
		"${SPDir}/ui/ui_connect.cpp"
		"${SPDir}/ui/ui_main.cpp"
		"${SPDir}/ui/ui_saber.cpp"
		"${SPDir}/ui/ui_shared.cpp"
		"${SPDir}/ui/ui_syscalls.cpp"
		"${SPDir}/ui/gameinfo.h"
		"${SPDir}/ui/menudef.h"
		"${SPDir}/ui/ui_local.h"
		"${SPDir}/ui/ui_public.h"
		"${SPDir}/ui/ui_shared.h"
		)
	source_group("ui" FILES ${SPEngineUIFiles})
	set(SPEngineFiles ${SPEngineFiles} ${SPEngineUIFiles})


	# Ghoul2 files
	set(SPEngineGhoul2Files
		"${SPDir}/ghoul2/G2.h"
		"${SPDir}/ghoul2/ghoul2_gore.h"
		)
	source_group("ghoul2" FILES ${SPEngineGhoul2Files})
	set(SPEngineFiles ${SPEngineFiles} ${SPEngineGhoul2Files})


	# Server files
	set(SPEngineCGameFiles
		"${SPDir}/cgame/cg_public.h"
		"${SPDir}/cgame/animtable.h"
		)
	source_group("cgame" FILES ${SPEngineCGameFiles})
	set(SPEngineFiles ${SPEngineFiles} ${SPEngineCGameFiles})

	if(WIN32)
		set(SPEngineWin32Files
			"${SPDir}/win32/resource.h"
			"${SPDir}/win32/winquake.rc"
			"${SharedDir}/sys/win_manifest.manifest"
			)
		source_group("win32" FILES ${SPEngineWin32Files})
		set(SPEngineFiles ${SPEngineFiles} ${SPEngineWin32Files})
	endif()

	set(SPEngineSysFiles
		"${SharedDir}/sys/sys_main.cpp"
		"${SharedDir}/sys/sys_event.cpp"
		"${SharedDir}/sys/sys_local.h"
		"${SharedDir}/sys/sys_public.h"
		"${SharedDir}/sys/sys_loadlib.h"
		"${SharedDir}/sys/con_local.h"
		"${SharedDir}/sys/con_log.cpp"
		"${SharedDir}/sdl/sdl_qgl.h"
		"${SharedDir}/sdl/sdl_sound.cpp"
		"${SharedDir}/sdl/sdl_input.cpp"
		"${SharedDir}/sdl/sdl_window.cpp"
		"${SharedDir}/sdl/sdl_icon.h"
		)

	if(WIN32)
		set(SPEngineSysFiles
			${SPEngineSysFiles}
			"${SharedDir}/sys/sys_win32.cpp"
			"${SharedDir}/sys/con_passive.cpp"
			)
	else()
		set(SPEngineSysFiles
			${SPEngineSysFiles}
			"${SharedDir}/sys/sys_unix.cpp"
			"${SharedDir}/sys/con_tty.cpp"
			)
	endif()

	source_group("sys" FILES ${SPEngineSysFiles})
	set(SPEngineFiles ${SPEngineFiles} ${SPEngineSysFiles})

    # Transparently use our bundled minizip.
    list(APPEND SPEngineIncludeDirectories ${MINIZIP_INCLUDE_DIRS})
    list(APPEND SPEngineLibraries          ${MINIZIP_LIBRARIES})

    # Transparently use either bundled or system zlib.
    list(APPEND SPEngineIncludeDirectories ${ZLIB_INCLUDE_DIR})
    list(APPEND SPEngineLibraries          ${ZLIB_LIBRARIES})

	# project macro so we can invoke it twice: for jk2 and for ja
	function(add_sp_project ProjectName Label SPDirName InstallDir Component)
		if(MakeApplicationBundles)
			set_source_files_properties(${SPDirName}/macosx/OpenJK.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
			set(SPEngineFiles ${SPEngineFiles} ${SPDirName}/macosx/OpenJK.icns)
			set_source_files_properties(${SPDirName}/macosx/English.lproj/InfoPlist.strings PROPERTIES MACOSX_PACKAGE_LOCATION Resources/English.lproj)
			set(SPEngineFiles ${SPEngineFiles} ${SPDirName}/macosx/English.lproj/InfoPlist.strings)
		endif(MakeApplicationBundles)

		if(WIN32)
			add_executable(${ProjectName} WIN32 ${SPEngineFiles})
			if(UseInternalSDL2)
				if(CMAKE_SIZEOF_VOID_P EQUAL 4)
					set(SPEngineExtraInstallFiles
						${OpenJKLibDir}/SDL2/bin/x86/SDL2.dll
						)
				else()
					set(SPEngineExtraInstallFiles
						${OpenJKLibDir}/SDL2/bin/x64/SDL2.dll
						)
				endif()
			endif()

## openjk 0~20190221.8367be0~dfsg

=== debian/changelog ===
openjk (0~20190221.8367be0~dfsg-1) experimental; urgency=medium

  * New upstream snapshot
  * AppArmor: Mark Mesa shader cache rules as obsoleted by apparmor 2.13
  * AppArmor: Rename AppArmor profiles to decouple the name from the
    attachment, as per
    https://lists.ubuntu.com/archives/apparmor/2018-August/011791.html
  * Standards-Version: 4.3.0 (no changes required)
  * Use debhelper-compat (= 12)
    - Add ${misc:Pre-Depends} to all packages (no functional change for
      packages other than openjk-server)
  * d/*.lintian-overrides: Justify why README.jedi-*-data need to be
    outside /usr/share/doc

 -- Simon McVittie <smcv@debian.org>  Sun, 17 Mar 2019 18:00:40 +0000

openjk (0~20180917.cc4094c~dfsg-1) experimental; urgency=medium

  * Revert "Update maintainer address"
    The lists.alioth.debian.org form is still canonical.
  * New upstream snapshot
  * d/p/JK2-Remove-mismatched-allocator-from-std-map-typedefs.patch:
    Remove, applied upstream
  * Standards-Version: 4.2.1 (no changes required)

 -- Simon McVittie <smcv@debian.org>  Mon, 01 Oct 2018 15:20:03 +0100

openjk (0~20180606.9736ae6~dfsg-1) experimental; urgency=medium

  * Update maintainer address
  * New upstream snapshot
  * d/copyright: Update
  * Build-depend on cmake >= 3.1 as per CMakeLists.txt
  * d/p/JK2-Remove-mismatched-allocator-from-std-map-typedefs.patch:
    Add patch to fix FTBFS with gcc 8 (Closes: #905477)
  * Standards-Version: 4.2.0 (no changes required)

 -- Simon McVittie <smcv@debian.org>  Mon, 06 Aug 2018 16:11:50 +0100

openjk (0~20180414.698fe7c~dfsg-1) experimental; urgency=medium

  * New upstream snapshot
  * d/copyright: Update Files-Excluded
  * d/watch: Watch for new versions from git
  * d/rules: Remove get-orig-source target
  * d/copyright: Update

 -- Simon McVittie <smcv@debian.org>  Fri, 20 Apr 2018 10:29:00 +0100

openjk (0~20180102~dfsg-1) experimental; urgency=medium

  * New upstream snapshot 32dcb33b
  * Change Vcs-* from debiangames-team to games-team
  * AppArmor: Sync profile from ioquake3
    - Use <abstractions/wayland> from apparmor (>= 2.10.95-5) instead
      of reinventing it
    - Allow reading EGL vendor configuration

 -- Simon McVittie <smcv@debian.org>  Sat, 27 Jan 2018 22:00:20 +0000

openjk (0~20171228~dfsg-1) experimental; urgency=medium

  * New upstream snapshot 01dd4909
  * Build-depend on SDL 2.0.7 so we have at least the version bundled
    by upstream
  * Standards-Version: 4.1.3 (no changes required)
  * Move to debhelper compat level 11
  * Move packaging to salsa.debian.org

 -- Simon McVittie <smcv@debian.org>  Mon, 01 Jan 2018 12:28:22 +0000

openjk (0~20171104~dfsg-1) experimental; urgency=medium

  * New upstream snapshot
  * Standards-Version: 4.1.1 (no changes required)
  * Set Rules-Requires-Root to no

 -- Simon McVittie <smcv@debian.org>  Mon, 06 Nov 2017 10:45:18 +0000

openjk (0~20170718+dfsg1-2) experimental; urgency=medium

  * Add patch adapted from ioquake3 to avoid a read buffer overflow
    in MSG_ReadBits (CVE-2017-11721), and check a buffer boundary
    more accurately in MSG_WriteBits (believed to be merely a bug, not
    a vulnerability).

 -- Simon McVittie <smcv@debian.org>  Sat, 05 Aug 2017 12:25:55 +0100

openjk (0~20170718+dfsg1-1) experimental; urgency=medium

  * New upstream snapshot
  * debian/apparmor.d: Allow more device enumeration
  * Declare compliance with Debian Policy 4.0.0

 -- Simon McVittie <smcv@debian.org>  Mon, 24 Jul 2017 07:42:11 +0100

openjk (0~20170610+dfsg1-1) experimental; urgency=medium

  * Reference CVE-2017-6903 in previous changelog entry
  * New upstream snapshot

 -- Simon McVittie <smcv@debian.org>  Thu, 15 Jun 2017 09:55:29 +0100

openjk (0~20170314+dfsg1-1) experimental; urgency=high

  * New upstream snapshot with security fixes
    (Closes: #857715; CVE-2017-6903)
    - Drop patches that were applied upstream

 -- Simon McVittie <smcv@debian.org>  Tue, 14 Mar 2017 10:22:34 +0000

openjk (0~20170122+dfsg1-1) experimental; urgency=medium

  * New upstream snapshot
    - Drop patches that were applied upstream
  * Add a patch to fix compilation on big-endian CPUs

 -- Simon McVittie <smcv@debian.org>  Wed, 22 Feb 2017 11:27:39 +0000

openjk (0~20170112+dfsg1-1) experimental; urgency=medium

  * New upstream snapshot
    - Drop patches that were applied upstream
  * Add patches to fix bounds-checking in savegames, so valid saves
    are not rejected
  * debian/apparmor.d/usr.games.openjk: Allow more device enumeration

 -- Simon McVittie <smcv@debian.org>  Sat, 21 Jan 2017 20:26:05 +0000

openjk (0~20161025+dfsg1-1) experimental; urgency=medium

  * New upstream snapshot
    - 64-bit builds now have the same saved game format as 32-bit builds
      with the same endianness
    - compatibility break: 64-bit saved games made prior to this version
      are no longer supported
  * d/p/Suppress-compiler-warning-for-unused-BufferToHexString.patch,
    d/p/Use-same-mechanism-to-say-no-servers-found-as-to-say-how-.patch,
    d/p/botlib-print-long-int-correctly.patch,
    d/p/Declare-platform-independent-byteswapping-functions-QINLI.patch,
    d/p/Fix-a-typo-in-Siege-mode-attemtping-attempting.patch:
    drop, applied upstream
  * d/p/Pick-up-date-from-SOURCE_DATE_EPOCH-for-reproducible-buil.patch:
    alter to define SOURCE_DATE in q_platform.h as requested upstream
  * d/p/Consistently-use-static-QINLINE-for-inline-C-code.patch,
    d/p/g_svcmds-fix-typo-in-avoiding-non-C-11-compliant-string-s.patch,
    d/p/savegames-bounds-check-some-string-lengths-to-prevent-buf.patch:
    more bugfix patches
  * d/p/Avoid-compiler-warning-when-sscanf-writes-qboolean-throug.patch:
    fix one more instance of the same issue
  * openjk-academy-server: depend on lsb-base as recommended by Lintian

 -- Simon McVittie <smcv@debian.org>  Fri, 28 Oct 2016 12:10:23 +0100

openjk (0~20160911+dfsg1-2) experimental; urgency=medium

  * Correct `date` invocation for $SOURCE_DATE_EPOCH


=== debian/control ===
Source: openjk
Section: contrib/games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Simon McVittie <smcv@debian.org>
Build-Depends:
 cmake (>= 3.1),
 debhelper-compat (= 12),
 dh-apparmor [linux-any],
 dh-exec,
 dpkg-dev (>= 1.16.1),
 icnsutils,
 imagemagick,
 libboost-test-dev,
 libjpeg-dev,
 libpng-dev,
 libsdl2-dev (>= 2.0.7~),
 zip,
Rules-Requires-Root: no
Standards-Version: 4.3.0
Vcs-Git: https://salsa.debian.org/games-team/openjk.git
Vcs-Browser: https://salsa.debian.org/games-team/openjk
Homepage: https://github.com/JACoders/OpenJK

Package: openjk-academy
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 jedi-academy-data (>= 1.01+41) | game-data-packager (>= 41),
 openjk-common (= ${binary:Version}),
Breaks:
 apparmor (<< 2.10.95-5~),
Description: Jedi Academy single-player and multiplayer game engine
 Star Wars Jedi Knight: Jedi Academy is a first- and third-person
 action game set in the Star Wars universe, developed by Raven Software
 and first released in 2003.
 .
 This package contains the openjk_sp and openjk, the OpenJK single-player
 and multiplayer game engines for Jedi Academy, based on the 2013 GPL
 source release and modified to work on modern systems.
 It requires non-distributable game data files in the
 jedi-academy-data package, prepared using the game-data-packager tool.
 .
 Jedi Academy is a sequel to Star Wars Jedi Knight II: Jedi Outcast, for
 which an experimental engine is available in the openjk-outcast package.

Package: openjk-academy-server
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 adduser,
 jedi-academy-data (>= 1.01+41) | game-data-packager (>= 41),
 lsb-base (>= 3.0-6),
 openjk-common (= ${binary:Version}),
Description: Jedi Academy multiplayer game server
 Star Wars Jedi Knight: Jedi Academy is a first- and third-person
 action game set in the Star Wars universe, developed by Raven Software
 and first released in 2003.
 .
 This package contains openjkded, the OpenJK multiplayer dedicated server
 for Jedi Academy, based on the 2013 GPL source release and modified to work
 on modern systems. It also contains init scripts to run the server
 automatically; on systemd systems, multiple instances are supported.
 .
 OpenJK requires non-distributable game data files in the jedi-academy-data
 package, prepared using the game-data-packager tool.

Package: openjk-outcast
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 jedi-outcast-data (>= 1.04+41) | game-data-packager (>= 41),
 openjk-common (= ${binary:Version}),
Breaks:
 apparmor (<< 2.10.95-5~),
Description: experimental Jedi Outcast single-player game engine
 Star Wars Jedi Knight II: Jedi Outcast is a first- and third-person
 action game set in the Star Wars universe, developed by Raven Software
 and first released in 2002.
 .
 This package contains openjo_sp, the OpenJK single-player game engine for
 Jedi Outcast, based on the 2013 GPL source release and modified to work
 on modern systems. It requires non-distributable game data files in the
 jedi-outcast-data package, prepared using the game-data-packager tool.
 .
 This version of the OpenJK engine is a mixture of code originating from
 Jedi Outcast and its sequel Jedi Academy; it is not currently considered to
 be stable, and does not have a multiplayer component. See the openjk-academy
 package for the sequel, Star Wars Jedi Knight: Jedi Academy, which is more
 stable and does support multiplayer.

Package: openjk-common
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 game-data-packager (>= 41),
Description: common files for all OpenJK games
 This package contains files shared by all versions of the OpenJK engine.
 It is used by the openjk-academy, openjk-outcast and openjk-academy-server
 packages.
 .
 It is unnecessary to install this package unless you are installing one
 of the packages that depends on it.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# Flags valid in both CFLAGS and CXXFLAGS
compiler_flags := \
	-Wall \
	-Wno-unused-parameter \
	-Wno-missing-field-initializers \
	-fno-strict-aliasing \
	-Wno-strict-aliasing \
	-Wno-unused-but-set-variable \
	$(NULL)
DEB_CFLAGS_MAINT_APPEND := \
	$(compiler_flags) \
	$(NULL)
DEB_CXXFLAGS_MAINT_APPEND := \
	$(compiler_flags) \
	$(NULL)
# OpenJK assumes that absence of -D_DEBUG implies -DNDEBUG
DEB_CPPFLAGS_MAINT_APPEND := \
	-DNDEBUG \
	$(NULL)
DEB_LDFLAGS_MAINT_APPEND := \
	-lm \
	$(NULL)

include /usr/share/dpkg/default.mk

# OpenJK upstream consider their support for Jedi Knight II: Jedi Outcast
# to be very much experimental, so don't build it for unstable or Ubuntu
# by default. Override with DEB_BUILD_OPTIONS=[no]outcast
ifneq (,$(filter nooutcast,$(DEB_BUILD_OPTIONS)))
$(info Disabling JK2 because DEB_BUILD_OPTIONS=nooutcast)
with_jk2 = OFF
else
ifneq (,$(filter outcast,$(DEB_BUILD_OPTIONS)))
$(info Enabling JK2 because DEB_BUILD_OPTIONS=outcast)
with_jk2 = ON
else
ifeq (,$(filter-out experimental UNRELEASED,$(DEB_DISTRIBUTION)))
$(info Enabling JK2 because this is an experimental or UNRELEASED build)
with_jk2 = ON
else
$(info Disabling JK2 by default)
with_jk2 = OFF
endif
endif
endif

dh_options =
ifneq ($(with_jk2),ON)
dh_options += -Nopenjk-outcast
endif

# for convenience, use a builddir that is excluded by upstream's .gitignore
%:
	dh $@ --builddir=obj $(dh_options)

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBuildJK2SPEngine=$(with_jk2) \
		-DBuildJK2SPRdVanilla=$(with_jk2) \
		-DBuildJK2SPGame=$(with_jk2) \
		-DBuildTests=ON \
		-DCMAKE_BUILD_TYPE=None \
		-DCMAKE_INSTALL_PREFIX=/usr/lib/openjk \
		-DCMAKE_VERBOSE_MAKEFILE=TRUE \
		$(NULL)

override_dh_auto_build: debian/icons
	dh_auto_build

override_dh_auto_install: DESTDIR = debian/tmp
override_dh_auto_install: debian/icons
	dh_auto_install
	cd $(DESTDIR)/usr/lib/openjk/JediAcademy && ln -s openjk_sp.* openjk_sp
	cd $(DESTDIR)/usr/lib/openjk/JediAcademy && ln -s openjk.* openjk
	cd $(DESTDIR)/usr/lib/openjk/JediAcademy && ln -s openjkded.* openjkded
	install -d $(DESTDIR)/usr/lib/openjk/JediAcademy/base
	rm -fv $(DESTDIR)/usr/lib/openjk/JediAcademy/base/*.so
	cd $(DESTDIR)/usr/lib/openjk/JediAcademy/base && ln -nfsv ../OpenJK/*.so .
	sed \
		-e 's!@IOQ3BINARY@!openjk_sp!' \
		-e 's!@IOQ3SELF@!openjk_sp!' \
		-e 's!@LIBDIR@!openjk/JediAcademy!' \
		-e 's!@DATA@!jedi-academy-data!' \
		-e 's!@IOQ3GAME@!Jedi Academy!' \
		-e 's!@IOQ3ROLE@!single-player!' \
		< debian/scripts/jedi.in > debian/scripts/openjk_sp
	sed \
		-e 's!@IOQ3BINARY@!openjk!' \
		-e 's!@IOQ3SELF@!openjk!' \
		-e 's!@LIBDIR@!openjk/JediAcademy!' \
		-e 's!@DATA@!jedi-academy-data!' \
		-e 's!@IOQ3GAME@!Jedi Academy!' \
		-e 's!@IOQ3ROLE@!multiplayer!' \
		< debian/scripts/jedi.in > debian/scripts/openjk
	sed \
		-e 's!@IOQ3BINARY@!openjkded!' \
		-e 's!@IOQ3SELF@!openjkded!' \
		-e 's!@LIBDIR@!openjk/JediAcademy!' \
		-e 's!@DATA@!jedi-academy-data!' \
		-e 's!@IOQ3GAME@!Jedi Academy!' \
		-e 's!@IOQ3ROLE@!server!' \
		< debian/scripts/jedi.in > debian/scripts/openjkded
ifeq ($(with_jk2),ON)
	cd $(DESTDIR)/usr/lib/openjk/JediOutcast && ln -s openjo_sp.* openjo_sp
	install -d $(DESTDIR)/usr/lib/openjk/JediOutcast/OpenJK
	cd $(DESTDIR)/usr/lib/openjk/JediOutcast/OpenJK && ln -s ../../JediAcademy/OpenJK/*.so .
	install -d $(DESTDIR)/usr/lib/openjk/JediOutcast/base
	rm -fv $(DESTDIR)/usr/lib/openjk/JediOutcast/base/*.so
	cd $(DESTDIR)/usr/lib/openjk/JediOutcast/base && ln -s ../OpenJK/jospgame*.so .
	cd $(DESTDIR)/usr/lib/openjk/JediOutcast/base && ln -s ../../JediAcademy/OpenJK/*.so .
	sed \
		-e 's!@IOQ3BINARY@!openjo_sp!' \
		-e 's!@IOQ3SELF@!openjo_sp!' \
		-e 's!@LIBDIR@!openjk/JediOutcast!' \
		-e 's!@DATA@!jedi-outcast-data!' \
		-e 's!@IOQ3GAME@!Jedi Knight II: Jedi Outcast!' \
		-e 's!@IOQ3ROLE@!single-player!' \
		< debian/scripts/jedi.in > debian/scripts/openjo_sp
endif
	chmod 0755 debian/scripts/openj*

ifeq ($(DEB_HOST_ARCH_OS),linux)
override_dh_install:
	dh_install
	dh_apparmor -popenjk-common --profile-name=usr.games.openjk
	dh_apparmor -popenjk-academy-server --profile-name=usr.games.openjkded
endif

override_dh_installchangelogs:
	dh_installchangelogs CHANGELOG.md

debian/icons: debian/rules
	install -d debian/icons/512 debian/icons/128 \
		debian/icons/64 debian/icons/32 debian/icons/16
	install -m644 shared/icons/OpenJK_Icon_128.png debian/icons/128/openjk.png
	install -m644 shared/icons/OpenJK_Icon_64.png debian/icons/64/openjk.png
	install -m644 shared/icons/OpenJK_Icon_32.png debian/icons/32/openjk.png
	install -m644 shared/icons/OpenJK_Icon_16.png debian/icons/16/openjk.png
	convert -resize 512x512 shared/icons/OpenJK_Icon_1024.png \
		debian/icons/512/openjk.png

# no libraries here, only plugins
override_dh_makeshlibs:
	:

override_dh_strip:
	dh_strip --dbgsym-migration='openjk-dbg (<< 0~20160320+dfsg1-1~)'

override_dh_clean:
	rm -fr debian/icons
	dh_clean

=== debian/watch ===
version=4
opts="mode=git,dversionmangle=s/[~+](dfsg|ds)[0-9]*$//,compression=xz,repacksuffix=~dfsg,pretty=0~%cd.%h" \
https://github.com/JACoders/OpenJK \
HEAD \
debian \
uupdate

## openjk 0~20190519.a2ea6ad~dfsg

=== debian/changelog ===
openjk (0~20190519.a2ea6ad~dfsg-1) experimental; urgency=medium

  * New upstream snapshot

 -- Simon McVittie <smcv@debian.org>  Wed, 12 Jun 2019 22:19:53 +0100

openjk (0~20190428.5f3389a~dfsg-1) experimental; urgency=medium

  * New upstream snapshot
  * d/*.links: Don't install symlinks to rv-readme.txt in openjk-common.
    rv-readme.txt was removed in 0~20160911+dfsg1-1: it doesn't provide
    useful information that isn't already in d/copyright. (Closes: #925447)

 -- Simon McVittie <smcv@debian.org>  Wed, 01 May 2019 08:09:10 +0100
